*
* Reproduces benchmark cross section regression results from 
* Mumtaz Sunder-Plassmann Theophilopoulou 
* "The state level impact of uncertainty shocks"
*

clear
set more off

insheet using xsection_bmk.txt, clear names double

rename state statestr
encode statestr, gen(state)
drop statestr
foreach var of varlist _all {
destring `var', force replace
}
order state

// right to work - code start year to dummy
gen rtw = 1
replace rtw = 0 if righttowork == 0 


// -----------------------------------------------------------------------------
// labels
// -----------------------------------------------------------------------------

label var stateirf_8 "IRF 2yr"
label var stateirf_4 "IRF 1yr"
label var empsh_250 "Small firms ($<250$)" //Employment share of firms <250 employees"
label var man "Manufacturing" // GDP share"
label var min "Mining" // GDP share"
label var con "Construction" // GDP share"
label var def2 "Budget deficit" //, share of expenditures"
label var intgov "Intergov't transfers" //, share of expenditures"
label var homevac "Home vacancy rate"
label var rtw "Right to work"



// -----------------------------------------------------------------------------
// regression
// -----------------------------------------------------------------------------

reg stateirf_8 man min homevac regdum, robust
reg stateirf_8 man min homevac rtw regdum, robust
reg stateirf_8 man min homevac empsh_250 rtw regdum, robust
reg stateirf_8 man min homevac def2 intgov rtw empsh_250 regdum, robust
reg stateirf_8 man min homevac def2 intgov rtw empsh_250 con regdum, robust
reg stateirf_4 man min homevac def2 intgov rtw empsh_250 con regdum, robust

