clear
addpath('../functions');
dfolder='../data/';
sfolder='./results/';
clc
maxfile=1; 
tic;
%inputs
%inputs
REPS=100000;%total reps
KEEP=5000;
BURN=REPS-KEEP;%burn in

nfiles=10;  %number of files to divide output in 
index=BURN:(REPS-BURN)/nfiles:REPS;
fsize=diff(index);
fsize=fsize(1);

L=4; %lags of endogenous variables
LH=4; %lags of volatility
nfact=3;
LV=1; %lags of idiosyncratic volatility
CHECK=1;
maxdraws=1000;
horizon=12;
T0=40;
irun=1;
Horz=20;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55555
file=maxfile;
  dfile=strcat(dfolder,'statedata','.mat');
load(dfile);
% tmp=dataS(:,11:12);
% dataS(:,11)=[];
% dataS(:,12)=[];
% dataS=[dataS(:,1) tmp dataS(:,2:end)];
%initial estimate of the factors
pmat=extract(dataS,nfact);
data=pmat;
data0=data;
Y=packr(data);
N=cols(data);
EX=((LH))+1;
ncrit=(N*L+EX);
X=[];
for j=1:L
X=[X lag0(data,j) ];
end
X=[X ones(rows(X),1) ];

Y=Y(L+1:end,:);
X=X(L+1:end,:);









%/////////////////Priors and starting values///////////////////////



%Minnesota type prior for the VAR coefficients via dummy observations
LAMDAP=1;
TAUP=10*LAMDAP;
EPSILON=1/1000;
EPSILONH=1; %closer to 0 tighter prior
RW=0;
[yd,xd,BETA0,SIGMA0]=getdummiesSS(LAMDAP,TAUP,EPSILON,Y,L,EX,LH,EPSILONH,RW);
%  BETA0=zeros(N*(N*L+EX),1);
%  SIGMA0=eye(N*(N*L+EX))*100;













%starting value for the stochastic volatility
y=Y(T0+1:end,:);
x=X(T0+1:end,:);
DATAS=dataS(T0+L+1:end,:);
data=data(T0+1:end,:);
pmat=pmat(T0+L+1:end,:);
res=DATAS-pmat*(pmat\DATAS);
T=rows(x);
if irun
[outh,outf,outg,outA]=getinitialvolc(data0,500,300,T0,L);
[outhx]=getsimplevol(res);

save initial outh outf outg outA outhx;
else
    load initial
end
%define priors for variances
vg0=5;             %prior df
g0=mean(outg);  %prior scale paramter for Q[i]~IG(g0,vg0)

c0= chofac(N,outA');

p00_a=1000;  %prior variances a1


%define priors for transition
F0=0.9;
S0f=eye(1)*0.1;

%define priors for unconditional mean of transition eq
MUF0=0;
SMUF0=0.1;
meanvol=zeros(1,1);
mubig=zeros(1,1);
ouths=standardise(log(outh));
  [tmp,lam]=extract(ouths,1);

h0=exp(tmp);
lam=h0\outh;
Qbig=mean(outg);
Sbig=lam./lam(1);

%define priors for variances
vs0=1;             %prior df
sx0=Sbig*vs0;  %prior scale paramter for s[i]~IG(g0,vg0)




hlast=zeros(T+1,(LH+1));
hlast(:,1)=h0;

i=1;
for j=2:cols(hlast)
hlag=lag0(h0,i);
hlag=packr(hlag);
hlag=[repmat(hlag(1,:),i,1);hlag];
hlast(:,j)=hlag;
i=i+1;
end
NN=cols(dataS);
elast=zeros(NN,T+1,LV+1);
elast(:,:,1)=outhx';
i=1;
for j=2:size(elast,3)
elag=lag0(outhx,i);
elag=packr(elag);
elag=[repmat(elag(1,:),i,1);elag];
elast(:,:,j)=elag';
i=i+1;
end



hnew=hlast;

xvar=[x(:,1:cols(X)-1) log(hlast(2:end,2:end)) x(:,end:end)];
varcoef0=xvar\y;
res=y-xvar*varcoef0;
varcoef0=vec(varcoef0)';
mu0=h0(1,:);
for j=1:LH
mu0=[mu0 h0(1,:)];  %ln(H0)~N(mu0,s0)
end
s0=eye(cols(mu0))*0.1;
is0=inv(s0);
NS=cols(hlast);

iamat=invpd(c0);

%priors for factor loadings and starting values
FMAT0=[];
for j=0:L-1
    FMAT0=[FMAT0 data(L-j,:)];
end
P00=eye(cols(FMAT0));


FLOAD0=zeros(NN,nfact+LV);
PFLOAD0=eye(nfact+LV)*1;
pmat0=pmat;

% for j=1:NN
%     
%         yy=DATAS(:,j);
%         xx=[pmat squeeze(log(elast(j,2:end,2:end)))];
%         BB=xx\yy;
%         FLOAD0(j,:)=BB';
%     
% end
VF0=0.01;
TF0=1;

%priors and starting values for idiosyncratic volatility
MUBAR=(elast(:,1,:));
SIGMABAR=eye(size(elast,3));
%define priors for transition
F0r=0.8;
S0fr=eye(1)*0.1;
%define priors for unconditional mean of transition eq
MUF0r=0;
SMUF0r=0.01;
meanvolr=zeros(1,NN);
mubigr=zeros(1,NN);
vr0=5;             %prior df
r0=0.01;  %prior scale paramter for Q[i]~IG(g0,vg0)
Qbigr=ones(1,NN).*r0;

maxh=max(max(outhx))*10;
save priors;
%Gibbs algorithm
amatsave=zeros(fsize,N,N);

bsave=zeros(fsize,1,N*(N*L+EX));
fsave=zeros(fsize,1,1+NN);
qsave=zeros(fsize,1,1+NN);
musave=zeros(fsize,1,1+NN);
hsave=zeros(fsize,T+1,1+NN);
Ssave1=zeros(fsize,1,N);
floadsave=zeros(fsize,NN,nfact+LV);
rmatsave=zeros(fsize,1,NN);
pmatsave=zeros(fsize,T,nfact);
naccept=zeros(T+1,1);
nacceptx=0;
jgibbs=1;
igibbs=1;
kgibbs=1;
while kgibbs<length(index)

    
    
  
  
  %step1 Sample VAR coefficients 
  [beta2,res,problem,numtrys]=...
      getvarcoef(y,xvar,yd,xd,...
      Sbig,iamat,hlast(2:end,1),maxdraws,L,EX);
if problem
    beta2=varcoef0;
else
    varcoef0=beta2;
    
end

 

 %step 3 sample offdiagonal elements
 [iamat,amat]=getamatonly(...
     res,Sbig,hlast(2:end,1),c0,p00_a,vs0,sx0,N);
 
 

 %Sample S

 Sbigout=getsbigonly(...
     res,Sbig,hlast(2:end,1),vs0,sx0,N,amat);
 Sbig=Sbigout;

%%%%%%%%%%%%%%%%%%%Step 5 Transition
%%%%%%%%%%%%%%%%%%%equation%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

ytemp=log(hlast(:,1))-meanvol(1);
xtemp=lag0(ytemp,1);
ytemp=ytemp(2:end,:);
xtemp=xtemp(2:end,:);
[F1,Q1]=getAR(ytemp,xtemp,F0,S0f,Qbig,g0,vg0);
fbig=F1;
Qbig=Q1;


  tmp=log(hlast(:,1))-lag0(log(hlast(:,1)),1)*fbig;
  ytemp=packr(tmp);
  xtemp=ones(rows(ytemp),1).*(1-fbig);
  ytemp=ytemp./sqrt(Qbig);
  xtemp=xtemp./sqrt(Qbig);
  MUJ=getreg(ytemp,xtemp,MUF0,SMUF0,1);
  mubig=(1-fbig).*MUJ;
  meanvol=MUJ;




%%%%%%%%%%%%Step 5 Stochastic vol%%%%%%%%
Fmat=zeros(NS,NS);
Fmat(1:1,1:1)=fbig(1);
Qmat=zeros(NS,NS);
Qmat(1:1,1:1)=Qbig;
iQmat=zeros(NS,NS);
iQmat(1:1,1:1)=1/(Qbig);
mumat=zeros(NS,1);
mumat(1,1)=mubig(1,1);
Fmat(2:NS,1:NS-1)=eye(NS-1);
cQQ=sqrt(Qmat);
varcoefx=reshape(beta2,N*L+EX,N); 
varcoef=[varcoefx(1:N*L,:);zeros(1,N);varcoefx(N*L+1:end,:)];
tt=1;                     %initial period
hleadx=hlast(tt+1,:);
[hh,nc]=svol1C(mu0,is0,hleadx,Fmat,Qmat,iQmat,mumat); %see Carlin Polson Stoffer example 1.1 expression for t=0
hnew(tt,:)=hh;
naccept(tt)=naccept(tt)+nc;

%time period 1 to T
for tt=2:T
hleadx=hlast(tt+1,:);
holdx=hlast(tt,:);

%////independence metropolis using f(h[t]\h[t+1],h[t-1]) as the candidate density
[hh,nc]=svolttCSSNOTREND(hnew(tt-1,:),hleadx,holdx,Fmat,Qmat,iQmat,cQQ,varcoef,iamat,y(tt-1,:),x(tt-1,:),mumat,Sbig);

hnew(tt,:)=hh;
naccept(tt)=naccept(tt)+nc;
end

%time period T+1
tt=T+1;
holdx=hlast(tt,:);

[hh,nc]=svoltCSSNOTREND(hnew(tt-1,:),holdx,Fmat,Qmat,iQmat,cQQ,varcoef,iamat,y(tt-1,:),x(tt-1,:),mumat,Sbig);

hnew(tt,:)=hh;
naccept(tt)=naccept(tt)+nc;

%update
hlast=hnew;
xvar=[x(:,1:cols(X)-1) log(hlast(2:end,2:end)) x(:,end:end)];

%step 7: Stochastic volatility for the observation equation

%transition equation
fbigr=zeros(1,NN);

for j=1:NN
ytemp=log(squeeze(elast(j,:,1)))'-meanvolr(j);
xtemp=lag0(ytemp,1);
ytemp=ytemp(2:end,:);
xtemp=xtemp(2:end,:);
[F1,Q1]=getAR(ytemp,xtemp,F0r,S0fr,Qbigr(j),r0,vr0);
fbigr(j)=F1;
Qbigr(j)=Q1;
end

for j=1:NN
  tmp=log(squeeze(elast(j,:,1)))'-lag0(log(squeeze(elast(j,:,1)))',1)*fbigr(j);
  ytemp=packr(tmp);
  xtemp=ones(rows(ytemp),1).*(1-fbigr(j));
  ytemp=ytemp./sqrt(Qbigr(j));
  xtemp=xtemp./sqrt(Qbigr(j));
  MUJ=getreg(ytemp,xtemp,MUF0r,SMUF0r,1);
  mubigr(j)=(1-fbigr(j)).*MUJ;
  meanvolr(j)=MUJ;
end

%factor loadings
[ fload,bload ] = ...
    getfloadSLnewxL( DATAS,pmat,...
    FLOAD0,PFLOAD0,elast,nfact,NN );


%sample volatilities
betaf=[fload zeros(rows(bload),1) bload];
enew=elast;
exor=zeros(T+1,NN);
parfor j=1:NN
    
    [etemp,naccepte]= ...
    getsvolMM(fbigr(j),Qbigr(j),...
    mubigr(j),betaf(j,:),...
    squeeze(elast(j,:,:)),squeeze(MUBAR(j,:,:))',...
    SIGMABAR,DATAS(:,j),pmat);
exor(:,j)=log(etemp)*[0 bload(j,:)]';    
enew(j,:,:)=etemp;
end
elast=enew;

%factors
H=zeros(NN,(nfact)*L);
H(1:NN,1:nfact)=fload;



%transition equation
betax=varcoefx(1:N*L,:);
exo=xvar(:,N*L+1:end)*varcoefx(N*L+1:end,:);
Fx=[betax';eye(N*(L-1),N*L)];



  [pmat,beta_tt]=getfactorSL(DATAS,H,...
      elast,Fx,FMAT0,P00,hlast,iamat,Sbig,exo,N,nfact,exor);
  
%   [pmatx,beta_ttx]=getfactorwSL(DATAS,H,...
%       elast,Fx,FMAT0,P00,hlast,iamat,Sbig,exo,N,nfact,exor);

%update data
data=pmat;
data=[data(1:L,:);data];
y=data;
x=[];
for j=1:L
x=[x lag0(data,j) ];
end
x=[x ones(rows(x),1) ];

y=y(L+1:end,:);
x=x(L+1:end,:);

if rem(igibbs,100)==0
    save('progress','pmat','elast','hlast','fbig','fbigr','mubig','mubigr','Qbig');
end


%impulse response to interest rate volatility
if igibbs>BURN
  
    if problem==0

    amatsave(jgibbs,:,:)=iamat;
bsave(jgibbs,:,:)=beta2;
fsave(jgibbs,:,:)=[fbig fbigr];
qsave(jgibbs,:,:)=[Qbig Qbigr];
musave(jgibbs,:,:)=[mubig mubigr];
hsave(jgibbs,:,:)=[hlast(:,1) elast(:,:,1)'];
Ssave1(jgibbs,:,:)=Sbig';
 
 floadsave(jgibbs,:,:)=[fload bload];%=zeros(fsize,NN,nfact);
pmatsave(jgibbs,:,:)=pmat;%=zeros(fsize,T,nfact);
    jgibbs=jgibbs+1;
    
    if sum(igibbs==index)
    sfile=strcat(sfolder,'output',num2str(kgibbs));    
     save(sfile,'amatsave',...
     'bsave','fsave',...
     'qsave','musave','hsave',...
     'naccept','Ssave1','floadsave','rmatsave','pmatsave');
      jgibbs=1;
      kgibbs=kgibbs+1;
    end
    
    
    
    
    end
end

disp(sprintf('Iteration Number= %s file no=%s ', num2str([igibbs ]),num2str(file)));
igibbs=igibbs+1;
end
