clear
addpath('../functions');
dfolder='../data/';
sfolder='./results/';
tic;
load priors
irun=0;
Horz=40;

sfilex=strcat(sfolder,'macro.mat');
load(sfilex,'mirf1','mirf2','irf1','irf2');

mirf1=prctile(irf1,[50 16 84],1);
mirf2=prctile(irf2,[50 16 84],1);

mirfc1=prctile(cumsum(irf1,2),[50 16 84],1);
mirfc2=prctile(cumsum(irf2,2),[50 16 84],1);

names=namesx;
  namesS=names(92:end);

tmp=squeeze(mirfc1(:,8,92:NN))';
figure(1)
xaxis=(1:51);
barh(xaxis,tmp(:,1),'y')
% % set(gca,'XTickLabel',namesS,'XTick',1:numel(namesS))
% xticklabel_rotate((1:51)',90,namesS)
for i=1:51
    text(-0.33,xaxis(i),namesS{i},'Rotation',0,'Color','r','FontWeight','bold')
end
ylim([1 51]);
xlabel('Percent Response');
vline(median(tmp(:,1)));



xlswrite('irfstates.xls',namesS,1,'A1')
tmpx=squeeze(mirfc1(1,:,92:end));
xlswrite('irfstates.xls',tmpx,1,'A2')
% tmp=squeeze(mirfc2(:,20,40:90))';
% figure(2)
% xaxis=(1:51);
% barh(xaxis,tmp(:,1),'y')
% % % set(gca,'XTickLabel',namesS,'XTick',1:numel(namesS))
% % xticklabel_rotate((1:51)',90,namesS)
% for i=1:51
%     text(-0.2,xaxis(i),namesS{i},'Rotation',0,'Color','r','FontWeight','bold')
% end
% ylim([1 51]);
namesX{1}='Industrial Production';

namesX{2}='Investment';
namesX{3}='Consumption';
namesX{4}='GDP';
namesX{5}='Unemployment Rate';
namesX{6}='Employment';
namesX{7}='Average Hours';
namesX{8}='CPI Inflation';
namesX{11}='Corporate Bond Spread';
namesX{10}='Oil Prices';
namesX{9}='3 Month T-Bill Rate';
namesX{12}='Log Volatility';
figure(3)
index=[1 39 40 41 42 20 49 69 74 80 81 143];
for j=1:length(index)
    subplot(6,2,j)
    if j~=12
     plotx2((0:Horz-1)',mirfc1(:,:,index(j))');
    end
     if j==12
         plotx2((0:Horz-1)',mirf1(:,:,index(j))');
     end
     title(namesX{j})
end
    

% figure(100)
% j=92
%  plotx2((0:Horz-1)',mirf1(:,:,j)');
%  title(namesx{j})
out=[];
for j=92:NN
    
tmpx=getnotsignificanthorizon(mirf1(:,:,j)');
if isempty(tmpx)
    tmpx=0;
end
if length(tmpx)>1
    tmpx=tmpx(end);
end
out=[out;tmpx];
end


figure(5)
xaxis=(1:51);
barh(xaxis,out(:,1),'y')
% % set(gca,'XTickLabel',namesS,'XTick',1:numel(namesS))
% xticklabel_rotate((1:51)',90,namesS)
for i=1:51
    text(20,xaxis(i),namesS{i},'Rotation',0,'Color','r','FontWeight','bold')
end
ylim([1 51]);
xlim([0 25])
vline(median(out(:,1)));
xlabel('Quarters')

% % 
figure(6)
scatter(out,tmp(:,1),100,'filled')

for i=1:51
    if mod(i,2)==0
    text(out(i)+0.1,tmp(i,1),namesS{i},'Rotation',-2,'Color','r','FontWeight','bold','FontSize',7)
    else
         text(out(i)+0.1,tmp(i,1)-0.01,namesS{i},'Rotation',-2,'Color','r','FontWeight','bold','FontSize',7)
    end
        
end
xlabel('Persistence')
ylabel('Magnitude')
% % for j=1:length(out)
% % addtxt(out(j),tmp(j,1),namesS{j},8,0.4)
% % end



% load('..\jlndata\shock')
% figure(7)
% plotx2((0:Horz-1)',mirfc1(:,:,20)');
% hold on
% plot(0:39,mean(reshape(irfx(:,2),3,120/3))*100,'k')

load('..\jlndata\shockQ')
figure(7)
subplot(2,1,1)
plotx2((0:Horz-1)',mirfc1(:,:,20)');
hold on
plot(0:39,irfx(:,2)*100,'k')
title('Employment')

subplot(2,1,2)
plotx2((0:Horz-1)',mirfc1(:,:,1)');
hold on
plot(0:39,irfx(:,1)*100,'k')
title('IP')




load('..\jlndata\shockQinf')
figure(8)
plotx2((0:Horz-1)',mirfc1(:,:,69)');
hold on
plot(0:39,irfx(:,7)*100,'k')